#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "port_2k.h"
#include "adm689.h"

void close(void);
unsigned int analog_adjust(unsigned int);

int resource_no, mux128_num;

int main(int argc, char **argv)
{
	long splnum, count, divide, l;	/*  number of sampling, status */
	int chs;	/*  number of sampling, status */

	int	i, j, brd_num, rv, device_id[8], index[8], brd_no;
	WORD data, *buf_ptr;
	BYTE stat, cmdchar, board_char, board_num;
	DWORD start_time;
	BOOL quit, err;
	HGLOBAL hMem;

	printf("ADM-689PCI mFvOV1.2\n");

	switch (argc){
	case 1:
		brd_no = 0;
		break;
	case 2:
		sscanf(argv[1], "%d", &brd_no);
		break;
	default:
		printf("USAGE: TS689W2 board_no\n");
		return (-1);
	}

	for (i = 0; i <= 7; i++){
		device_id[i] = -1;
		index[i] = -1;
	}

	brd_num = 0;
	rv = Open_Driver(device_id);
	if (rv != 0){
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		exit (-1);
	}

	for (i = 0; i <= 7; i++)
		if (DEVICE_ID ==device_id[i])
			index[brd_num++] = i;

	if (brd_num == 0){
		printf("%soł܂B\n", BOARD_NAME);
		close();
	}
	else
		printf("%s%do܂B\n", BOARD_NAME, brd_num);

	if (brd_num <= brd_no){
		printf("board_no̎w肪Ă܂B");
		close ();
	}

	rv = Start_Driver(index[brd_no], 2, &resource_no);
	if (rv != 0){
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		close();
	}

	data = ReadByte(resource_no, RESET);
	if (data != BOARD_ID){
		printf("{[hID(=%02xH)ُłB\n", data);
		close();
	}
	printf("gpĂMUX-128̖͂ĉB\n");
	do{
		mux128_num = getch() - '0';
	}while( !((mux128_num >0) & (mux128_num < 9)));

    chs = MUX128_CH * mux128_num;
	splnum = 20;
	
	// `lݒ
	WriteByte(resource_no, CHNUM, (unsigned char)((chs - 1) & 0xff));
	WriteByte(resource_no, CHNUM, (unsigned char)((chs - 1) >> 8));

	/* select clock source */
	// POlggp
	WriteByte(resource_no, CLKSEL, INT_10M);
	WriteByte(resource_no, SCANRATE, 0x00);			// 10uS TvO

	// NbNWPDXQrɐݒ
	WriteByte(resource_no, CLKDIV, 0x00);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x80);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x0C);	// JE^aBYTE
	WriteByte(resource_no, CLKDIV, 0x00);	// JE^aBYTE
	
	/* make buffer area */
	hMem = GlobalAlloc(GHND, splnum * 2 * chs);
	buf_ptr = (LPWORD)GlobalLock(hMem);
	if (buf_ptr == 0L){
		printf("Not enough memory.\n");
		return (-1);
	}

	/* start sampling */
	WriteByte(resource_no, TRIG, SOFT_TRIG);

	/* loop for read data */
	count = 0L;
	l = 0L;
	do{
		stat = ReadByte(resource_no, STATUS);
	  	if (stat & SMP_ERR){
			WriteByte(resource_no, TRIG, STOP);	/* A/D stop */
			printf("Sampling Error in half full sampling!!\n");
			GlobalUnlock(hMem);
			GlobalFree(hMem);
			exit(1);
		}
		else if ((stat & NOT_HALF) != NOT_HALF){
			ReadByteBlock(resource_no, DATA, FIFO_HALF * 2, (BYTE *)(buf_ptr + l));
			l += FIFO_HALF;
			++count;
		}
		else
			;
	} while (count < (splnum * chs / FIFO_HALF));

	do{
		stat = ReadByte(resource_no, STATUS);
		if (stat & SMP_ERR){
			WriteByte(resource_no, TRIG, STOP);	/* A/D stop */
			printf("Sampling Error in not empty sampling!!\n");
			GlobalUnlock(hMem);
			GlobalFree(hMem);
			exit(1);
		}
		else if(stat & EOS_FLAG){
			WriteByte(resource_no, STSCLR, EOS_FLAG);
			ReadByteBlock(resource_no, DATA, chs * 2, (BYTE *)(buf_ptr + l));
			l += chs;
		}
		else
			;
	}while (l < splnum * chs);
	WriteByte(resource_no,TRIG, 0);				// TvO~
	WriteByte(resource_no,STSCLR,0x01);

	/*  display sampled data  */
	for (l = 0L; l < splnum; l++){
		for (i = 0; i < chs; i++){
			if (i % MUX128_CH == 0)
				printf("%dڂ̃f[^łB\n", (i / MUX128_CH) + 1);
			else
				;
			printf("%04x ", *(buf_ptr + l * chs + i));
		}
		printf("\n");
	}

	GlobalUnlock(hMem);
	GlobalFree(hMem);
	printf("\nsꍇ\"C/c\"L[AIꍇ\"E/e\"L[ĉB\n");
	do{
		cmdchar = getch();
	}while(cmdchar != 'E' & cmdchar != 'e' & cmdchar != 'C' & cmdchar != 'c');
	if (cmdchar == 'E' | cmdchar == 'e')
		;
	else {
		do{
			do{
				printf("\ltw|PQW{[hԍOV̊Ԃ̒lŎw肵ĉB\n");
				board_num = 'X';
				board_char = getch();
				switch(board_char){
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
						if((board_char - '0') > mux128_num){
							printf("͔͈͂w肳ꂽ𒴂Ă܂B");
							break;
						}
						else
							;
						board_num = board_char - '0';
						break;
					default:
						break;
				}
			}while(board_num == 'X');
			printf("	`lOPTTvO鎞\"0\"L[\n\
	PURPTvO\鎞\"1\"L[\n\
	RQSVTvO\鎞\"2\"L[\n\
	SWURTvO\鎞\"3\"L[\n\
	USVXTvO\鎞\"4\"L[\n\
	WOXTTvO\鎞\"5\"L[\n\
	XUPPPTvO\鎞\"6\"L[\n\
	PPQPQVTvO\鎞\"7\"L[\n\
	܂TvOI鎞\"E/e\"L[ĉB\n");
			cmdchar = getch();
			switch(cmdchar){
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
						if((board_char - '0') > mux128_num)
							break;
						else{
							analog_adjust( (unsigned int)(board_num * 8 + (cmdchar - '0')));
							cmdchar = getch();
						}
				break;
			default:
				break;
			}
		}while(cmdchar != 'E' & cmdchar != 'e');
	}
	return (0);
}

void close()
{
	int rv;
	
	rv = Close_Driver();
	if (rv != 0){
		printf("Close_DriverŃG[(%d)܂B\n", rv);
	}
	exit(-1);
}
unsigned int	analog_adjust( unsigned int channels )
{
	int chs, i, l;	/*  number of sampling, status */
	WORD data[MAX_CH], *data_ptr;
	BYTE stat;

	chs = MAX_CH;
	data_ptr = &data[0];
	
	do{
		stat = ReadByte(resource_no, RESET);
		// `lő`lɐݒ
		WriteByte(resource_no, CHNUM, (unsigned char)((chs - 1) & 0xff));
		WriteByte(resource_no, CHNUM, (unsigned char)((chs - 1) >> 8));
		// POlggp
		WriteByte(resource_no, CLKSEL, INT_10M);
		WriteByte(resource_no, SCANRATE, 0x00);			// 10uS TvO

		// NbNUPDSSrɐݒ
		WriteByte(resource_no, CLKDIV, 0x00);	// JE^`BYTE
		WriteByte(resource_no, CLKDIV, 0x60);	// JE^`BYTE
		WriteByte(resource_no, CLKDIV, 0x09);	// JE^aBYTE
		WriteByte(resource_no, CLKDIV, 0x00);	// JE^aBYTE
		/* start sampling */
		ReadByte(resource_no, MANUAL);

		/* loop for read data */
		l = 0L;
		do{
			stat = ReadByte(resource_no, STATUS);
			if(stat & SMP_ERR){
				WriteByte(resource_no, TRIG, STOP);
				printf("Sampling Error in not empty sampling!!\n");
				return(1);
			}
			else if(stat & EOS_FLAG){
				WriteByte(resource_no, STSCLR, EOS_FLAG);
				ReadByteBlock(resource_no, DATA, chs * 2, (BYTE *)data_ptr);
				l += chs;
			}
			else
				;
		}while (l < chs);

		/*  display sampled data  */
		for (i = channels * 16 ; i < (channels + 1) * 16; i++)
			printf("%02d-%04x ", i , data[i]);
		printf("\n");
	}while(!_kbhit());
	return(0);
}
